* Ministero Affari Esteri: Eventi e Contatti
*----------------------------------------------------------------------------------------------------------------------------

*-- SECTION GLOBAL COMMUNICATION
    *LPARAMETERS M.GS_LogicPath
    *M.GS_LogicPath=ALLTRIM(M.GS_LogicPath)

public m.vrelease as String
m.vrelease = "Versione 9.08/2005 - 23 Sett. 2021"

public m.VProgress  as Integer
m.VProgress  = 908

*-- LOCAL RESOURCE SETTINGS
	PUBLIC M.GS_LRP, M.GS_EMERGENCY, M.GS_CORE, m.GS_LogicPath, m.gs_imago   && Local Resource, Logic and Intelligence Point
	*M.GS_LRP=CURDIR()
	M.GS_LRP       = "C:\@Contatto\"
	M.GS_CORE      = "c:\@Contatto\"
	m.GS_LogicPath = "c:\@Contatto\"
	m.GS_Imago     = "c:\@Contatto\imago\"
	M.GS_EMERGENCY = .F.
	SET DEFAULT TO (M.GS_LRP)

  	ON KEY LABEL CTRL+F5 display status to C:\@Tempus\infobase.txt
	on key label CTRL+F6 SET SYSMENU TO DEFAULT
	ON KEY LABEL CTRL+F7 on error
	ON KEY LABEL CTRL+F8 wait window Str(txnlevel())

	
    ON KEY LABEL F11  keyboard "{ALT+A}"   plain clear
    ON KEY LABEL F12  keyboard "{ALT+X}"   plain clear
    ON KEY LABEL F9   keyboard "{ALT+I}"   plain clear
    ON KEY LABEL F10  keyboard "{ALT+M}"   plain clear
    ON KEY LABEL F8   keyboard "{ALT+S}"   plain clear
    ON KEY LABEL F7   keyboard "{ALT+P}"   plain clear
    
    ON KEY LABEL F2   keyboard "{ALT+2}"   plain clear
    ON KEY LABEL F3   keyboard "{ALT+3}"   plain clear
    ON KEY LABEL F4   keyboard "{ALT+4}"   plain clear
    ON KEY LABEL F5   keyboard "{ALT+5}"   plain clear
    

	on error

*-- GLOBAL CONTEXT SETTINGS
	#INCLUDE LABELS.H
    
    set enginebehavior 70
    
	SET TALK        OFF
	SET NOTIFY      OFF
	SET STATUS BAR  OFF
	SET SYSMENU     OFF 

	M.xAppTitle=""
	WITH _SCREEN     
	     .AutoCenter  = .T.
	     .Caption     = M.xAppTitle
	     .Icon        = (M.GS_LRP+"EARTH.ICO")
	     .Picture     = (M.GS_LRP+"BLOCCO.BMP")
	     .ShowTips    = .T.
	     .WindowState = 2
	     .Closable    = .f.
	ENDWITH   


* GLOBAL ERROR MANAGMENT
*------------+--------------------------------------------------------------------------
* Errore     |  Action
* -----------+--------------------------------------------------------------------------
* Warning    | Continua l'esecuzione avvertendo l'utente della situazione
* -----------+--------------------------------------------------------------------------
* Error      | Errore non bloccante
* -----------+--------------------------------------------------------------------------
* Severe     | Errore bloccante, l'esecuzione non pu continuare
* -----------+--------------------------------------------------------------------------
PUBLIC M.xiCheckContext

M.xiCheckContext = ""

****ON ERROR DO CheckManagError 


*-- GLOBAL MESSAGE RESOURCE
	PUBLIC M.MessageSended, M.MessageReceived
	M.MessageSended   = ""
	M.MessageReceived = 0

*-- GLOBAL SYSTEM ENVIRONEMENT     
	DO SetCoreContext

	M.Is_Fault  =.F.
	M.Cu_Fault  =ON("ERROR") 
	ON ERROR M.Is_Fault=.T.

	M.SysPath = ""
	M.IReturn = 0
	DO SystemDirectory WITH M.SysPath, M.IReturn 
	IF M.IReturn > 0
	   M.SysLoc=SUBSTR(M.SysPath,1,M.IReturn)+"\"
	   SET SAFETY OFF
	   COPY FILE (m.GS_LRP+"MSVCRT40.DLL") TO (M.SysLoc+"MSVCRT40.DLL")                    
	ENDIF

	IF NOT EMPTY(M.Cu_Fault)
	   ON ERROR &Cu_Fault
	ELSE
	   ON ERROR
	ENDIF
	M.xAppTitle = "|| ECO - Eventi e Contatti Management ||"
	M.xIReturn  = 0

	MODIFY WINDOW SCREEN          ;
	       TITLE  M.xAppTitle      ;
	       ICON FILE (M.GS_LRP+"EARTH.ICO")
    
*-- Global Methods
	M.PanelActive  =.F.        && Un Pannello Attivo 
	*ON KEY LABEL ALT+0      DO ShutDown.SPR

*-- GLOBAL FAULT MANAGER 
	*DO ActivateExpert IN Fault
  

*-- GLOBAL SUPPORT INFO STRUCTURES        
    set multilocks on
	SELECT 1
	USE (M.GS_LRP+"MEMORY") shared
	=CURSORSETPROP("Buffering",5,"MEMORY")
	   
	PUBLIC              ;
	M.GS_IBCheck,       ;
	M.GS_ISSERVER,      ;
	M.GS_WSTYPE,        ;
	M.GS_MANAGER,       ;
	m.gs_PManager,      ;
	M.GS_PREVIOUS,      ;
	M.GS_INFOPATH,      ;
	M.GS_MENUOFF,       ;
	M.GS_ANNO,          ;
	M.GS_DATA,          ;
	M.GS_MESE,          ;
	M.GS_MSG,           ;
	M.GS_Direct,        ;
	m.gs_InFolderLoop,  ;
	m.gs_PaperOnLoad,   ;
	m.gs_StopPaperLoad, ;
	m.gs_ShowTop,       ;
	m.gs_track,         ;
    m.gs_IBType
	  

	M.GS_INFOPATH     = IIF(EMPTY(ALLTRIM(MEMORY.IBPATH)),M.GS_LRP,ALLTRIM(MEMORY.IBPATH))
	M.GS_IBCheck      = .F.   && User Indicator Of Information Check-Up 
	M.GS_ISSERVER     = DRIVETYPE(JUSTDRIVE(ALLTRIM(MEMORY.IBPATH)))=3
	M.GS_WSTYPE       = IIF(M.GS_ISSERVER,"Server","Client")
	M.GS_MANAGER      = UPPER(ALLTRIM(MEMORY.MANAGER))	
	M.GS_PREVIOUS     = UPPER(ALLTRIM(MEMORY.MANAGER))
	M.GS_MENUOFF      = .F.
	
	M.GS_ANNO         = memory.GSANNO && Anno di Lavoro Corrente
	M.GS_DATA         = MEMORY.GSDATA
	M.GS_MESE         = MEMORY.GSMESE

	M.GS_MSG          = ""
	M.GS_Direct       = .f.
	m.gs_InFolderLoop = .f.
	m.gs_ShowTop      = .t.
	m.gs_Track        = .f.
    m.gs_IBType       = "Base Informativa CENTRALE"
	

		  
    *-- To Email list
        Public m.gs_ToEmailList as String
        m.gs_ToEmailList = ""


	*-- 
	* PREVIOUS MANAGER 
	* if not empty it must be the manage to whom it must return. 
	*--
	m.gs_PManager  = ""                                              

*-- Time
    public m.gs_clock as Date
    m.gs_clock = date()    

    
*-- Error Monitor
	PUBLIC       ;
	M.EM_NUMBER, ;
	M.EM_MSG

	M.EM_NUMBER  = 0
	M.EM_MSG     = ""
	DO Support


  Public  m.gs_ViewOnly  
  m.gs_ViewOnly    = .f.



*-- View Parameters and Settings
 
  
*-- GLOBAL CHECK AND ACCESS CONTROLLER
	DO FORM Access.SCX   && Entry Gate      
    m.GS_INFOPATH  = IIF(EMPTY(ALLTRIM(MEMORY.IBPATH)),M.GS_LRP,ALLTRIM(MEMORY.IBPATH))

	
	M.GS_IBCheck   = .F.   && User Indicator Of Information Check-Up 

	*M.GS_ISSERVER  = DRIVETYPE(JUSTDRIVE(ALLTRIM(MEMORY.IBPATH)))=3
	M.GS_ISSERVER  = .t.

	M.GS_WSTYPE    = IIF(M.GS_ISSERVER,"Client","SERVER")
	M.GS_MANAGER   = UPPER(ALLTRIM(MEMORY.MANAGER))
	M.GS_MENUOFF   = .F.
	M.GS_ANNO      = MEMORY.GSANNO
	M.GS_DATA      = MEMORY.GSDATA
	M.GS_MESE      = MEMORY.GSMESE
	M.GS_MSG       = ""
	M.GS_Direct    = .F.  && Selezione Diretta no via Top Panel
	m.GS_Cycle     = .t.
		
		  
	DO SetCoreContext

   

*-- Access Controller and Context Setting
	SELECT 2
	IF USED("USERS")
	   SELECT USERS
	ELSE      
	   OPEN DATABASE (M.GS_INFOPATH+"INFOBASE") SHARED
	   SELECT 2
	   USE (M.GS_INFOPATH+"USERS") SHARED
	   =CURSORSETPROP("Buffering",5,"users")
	ENDIF   

	*-- Versioning Alert
	    SELECT 03
	    USE
	    USE (ALLTRIM(m.GS_INFOPATH)+"gmemory.DBF" ) SHARED
	    =CURSORSETPROP("Buffering",5,"gmemory")	   

	*-- User Framework
		PUBLIC           ;
		m.GS_USERNAME,   ;
		M.GS_PASSWORDID, ;
		m.GS_RIGTHS,     ;
		m.gs_ruolo,      ;
		m.gs_sigla,      ;
		m.gs_clist
		
		public m.gs_new, m.gs_modify, m.gs_kill
        store .t. to m.gs_new, m.gs_modify, m.gs_kill 		
		
		M.GS_USERNAME    = ""  
		M.GS_PASSWORDID  = ""
		M.GS_RIGTHS      = "" 
		m.gs_ruolo       = upper(alltrim(memory.ruolo))
		m.gs_sigla       = ""
		m.gs_clist       = ""
	 

		*-- Ruoli Operativi
			public array isl_ruoli[04]
			isl_ruoli[01] = "AMMINISTRATORE   "
			isl_ruoli[02] = "UTENTE OPERATIVO "
			isl_ruoli[03] = "CONSULTAZIONE    "
			isl_ruoli[04] = "SUPER UTENTE     "

	
	
	DO FORM TopGate.SCX  && Gate di Accesso   
	LOCAL M.BackInfo, M.SType
	M.BackInfo = SPACE(250)
	M.SType    = IIF(M.GS_ISSERVER,1,2)
	
	LOCAL M.xUser, M.xPass
	M.xUser  = ""
	M.xPass  = ""

	m.xUser  = memory.uname
	m.xPass  = ""
	m.xRuolo = memory.uprofile

  If  Not m.gs_ViewOnly  then
			DO WHILE .T.	   
			   *EXIT	  && +++++++++++++++++ 
			   DO FORM LOGIN.SCX ;
			      WITH "Digitare i codici di accesso riservati", ;
			           1, ;
			           M.SType, ;
			           M.xUser, ;
			           M.xPass, ;
			           m.xRuolo ;
			   TO M.BackInfo
			   
			   *wait window SUBSTR(M.BackInfo,42,1)
			   
			   DO CASE
			      CASE VAL(SUBSTR(M.BackInfo,42,1)) = 1
			      
			           m.GS_USERNAME    = ALLTRIM(SUBSTR(M.BackInfo,1,20))
			           M.GS_PASSWORDID  = ALLTRIM(SUBSTR(M.BackInfo,21,40))	           	           
			           M.GS_IBCheck     = IIF(VAL(SUBSTR(M.BackInfo,41,1)) = 1,.T.,.F.)
			           m.gs_ruolo       = ALLTRIM(SUBSTR(M.BackInfo,61,39))
			           m.gs_sigla       = ALLTRIM(SUBSTR(M.BackInfo,120,10))
			           m.gs_clist       = ALLTRIM(SUBSTR(M.BackInfo,201,40))
			           
			           M.GS_RIGTHS      = ALLTRIM(SUBSTR(M.BackInfo,43,60)) 
			           
			           
		 	           m.gs_New         = iif(val(substr(M.GS_RIGTHS,1,1))=1,.t.,.f.)   
			           m.gs_Modify      = iif(val(substr(M.GS_RIGTHS,2,1))=1,.t.,.f.)   	           
			           m.gs_Kill        = iif(val(substr(M.GS_RIGTHS,3,1))=1,.t.,.f.)   
			           
			           EXIT
			               
			      CASE VAL(SUBSTR(M.BackInfo,42,1)) = 3
			           SET TALK OFF
			           SET NOTIFY OFF
			           QUIT
			   ENDCASE
	         
       	Enddo


		 	 RELEASE WINDOWS TOPGATE
		 	
		  	begin transaction
		 	select memory
		 	replace memory.uprofile with m.gs_ruolo
		 	replace memory.uname    with m.gs_username
		    * Store Data             
		    LOCAL M.CIBStatus
		    M.CIBStatus = TABLEUPDATE(1,.F.,"memory")
		    
		    IF M.CIBStatus
		       END TRANSACTION
		    ELSE              
		       Rollback
		    Endif 
		    
 	else	   
 	 
		   RELEASE WINDOWS TOPGATE  	
       	
   Endif 
   
      
      
 	
 
 
*------------------------------------------------------------------------------------------------------------------------
* Global Work Area: Work Card
*------------------------------------------------------------------------------------------------------------------------

 	
*------------------------------------------------------------------------------------------------------------------------
* AREA META - INTELLIGENCE 
*------------------------------------------------------------------------------------------------------------------------



  SELECT 1
  USE (M.GS_LRP+"MEMORY") shared
  *DO SetCustomEnv WITH MEMORY.IBPATH 
  =SetCustomEnv(m.GS_INFOPATH)

  *-- Re-Set Context
      DO SetCoreContext      
      =GetAPIEnv()
     
     
  *-- Selezione Lista di Pubblicit 
	  *=SelectLista()
      
  *-- Barcode Section
      Public loIDCARD as Object
  	  loIDCARD = CREATEOBJECT("FoxBarCode")
	  loIDCARD.nBarCodeType = 110 && Cod_128
	  loIDCARD.cSet128 = "*"
	  loIDCARD.nFactor = 1
	  loIDCARD.nImageHeight = 50 && in pixels
	  loIDCARD.cImageType = IIF(VERSION(5) > 600, "PNG", "JPG")
	  loIDCARD.lShowHumanReadableText = .F.      

  *-- Setting of Global Variables related to Document Management

        
*-- Top Main Cycle  
    M.GS_MANAGER  = "" 
    m.gs_ShowTop  = .t.
    
    m.gs_autoclose = .f.
        
    do while .t.

	       	     
	     CLEAR READ ALL   
	     CLEAR
	     
	     DO CASE 
	     *- Work Folder
	        CASE m.GS_MANAGER=="UCM_ECO"
	             
		        
		             M.GS_MSG       = ""
		             SELECT MEMORY
		             REPLACE MEMORY.MANAGER WITH M.GS_MANAGER	             
		             DO DBMCT WITH "BASE_CONTEXT",""        
		             
		             DO FORM ucm_eco.SCX
	                 read events
	                 
	             
	             
	        CASE m.GS_MANAGER=="UCM_AGENDA"
	             

		             M.GS_MSG       = ""
		             SELECT MEMORY
		             REPLACE MEMORY.MANAGER WITH M.GS_MANAGER	             
		             DO DBMCT WITH "BASE_CONTEXT",""        
		             
		             DO FORM ucm_agenda.SCX
	                 read events
	                 
	                 
	     *- Ricerca Card
	        CASE M.GS_MANAGER=="USM_RICERCACARD"
	             local m.xReturnCode, m.xRecNo
	             M.GS_MSG       = ""
	             
	             SELECT MEMORY
	             REPLACE MEMORY.MANAGER WITH M.GS_MANAGER	
	                          
	             DO DBMCT WITH "BASE_CONTEXT",""         
	             
				 select contatto
				 m.xRecNo = recno("contatto")
				 
				 m.xReturnCode=GetCard()
				 
				 *Wait Window Str(m.xReturnCode)
				
				 if m.xReturnCode > 0 then
				   
				    set exact on
				    if not seek(m.xReturnCode,"contatto","v0") then
					    select contatto
					    go m.xRecNo      
				    endif 
				         				      
				  else
				       select contatto
				       go m.xRecNo
				 endif
				
				 m.GS_MANAGER="UCM_ECO"
				 loop				                      	             



	     *- Ricerca in Registro Telefonate
	        CASE M.GS_MANAGER=="USM_RICERCAREG"
	             local m.xReturnCode, m.xRecNo
	             M.GS_MSG       = ""
	             
	             SELECT MEMORY
	             REPLACE MEMORY.MANAGER WITH M.GS_MANAGER	
	                          
	             DO DBMCT WITH "BASE_CONTEXT",""         
	             
				 select cagenda
				 m.xRecNo = recno("cagenda")
				 
				 m.xReturnCode=GetReg()
				
				 if m.xReturnCode > 0 then
				   				   
					select cagenda
					go m.xReturnCode

				         				      
				  else
				       select contatto
				       go m.xRecNo
				 endif
				
				 m.GS_MANAGER="UCM_AGENDA"
				 loop				        
	             
	        OTHERWISE
	             m.GS_MANAGER="UCM_ECO"
	             loop

	     Endcase 
	     
	     
	Enddo    

*-------------------------------------------------------------------------------------------------------------------------------
* AREA INTELLIGENT UNITS
*-------------------------------------------------------------------------------------------------------------------------------
PROCEDURE SetCoreContext

*-- AREA INTELLIGENCE
	SET LIBRARY   TO    
	SET LIBRARY   TO  (M.GS_LRP+"FOXTOOLS.FLL")  ADDITIVE

	SET PROCEDURE TO  (M.GS_LRP+"COREBASE")      ADDITIVE && Base of Activity
	SET PROCEDURE TO  (M.GS_LRP+"CORECORE")      ADDITIVE && Core  
	SET PROCEDURE TO  (M.GS_LRP+"COREVENT")      ADDITIVE && Core Event  
	SET PROCEDURE TO  (M.GS_LRP+"COREAPI")       ADDITIVE && API 
	SET PROCEDURE TO  (M.GS_LRP+"COREPH")        ADDITIVE && Physical Integrity
	SET PROCEDURE TO  (M.GS_LRP+"CORESAC")       ADDITIVE && Security and Access Control
	SET PROCEDURE TO  (M.GS_LRP+"COREIR")        ADDITIVE && Information Retrival

	SET PROCEDURE TO  (M.GS_LRP+"coreclass")     ADDITIVE && Base Class
	
	SET PROCEDURE TO  (M.GS_LRP+"FoxBarcode")    ADDITIVE && BarCode Service
	SET PROCEDURE TO  (M.GS_LRP+"gpImage2")      ADDITIVE && BarCode Service
	
	
	*Set Procedure To  (M.GS_LRP+"EmployeeWorkClass") Additive 
	
*!*		Set Classlib To
*!*		Set Classlib To   (M.GS_LRP+"EmployeeWorkClass") Additive 


	*!*	SET CLASSLIB TO
	*!*	SET CLASSLIB TO (M.GS_CORE+"Class01")   ADDITIVE && Meta-Intelligence Base
	*
ENDPROC
*-------------------------------------------------------------------------------------------------------------------------------
PROCEDURE CheckManagError ( M.xiCheckContext )

   * Area Intelligence
   *M.xiCheckContext = UPPER(ALLTRIM(M.xiCheckContext))
   *+++
   DO CASE
            
      OTHERWISE
          DO FORM Fault.SCX   
   ENDCASE
   
   
  RETURN
ENDPROC
*-------------------------------------------------------------------------------------------------------------------------------





