* Custom Environment and Coding/Decoding Information
*--------------------------------------------------------------------------------------------------------------------------------
PROCEDURE SetCustomEnv 
***
* Purpose  > Set Custom Environment
***
* Section Communication
LPARAMETERS m.xi_IBPath

* Area Intelligence

  *-- Data Editing Section
	  SET BRSTATUS ON
	  SET CARRY    OFF
	  SET CENTURY  ON
	  set decimals to 4
  
  *-- Display Section
	  SET CLOCK  STATUS
	  SET CURSOR ON
	  SET DEVICE TO SCREEN
	  SET NOTIFY OFF
  
  *-- Output Section
	  SET CONSOLE OFF
	  SET DATE    TO ITALIAN
	  SET HOURS   TO 12
	  SET TALK    OFF
	  SET CENTURY ON 
  
  * Input Section   
  *-- Files Section 
	  SET ALTERNATE OFF  && No alternate files containing all output
	  SET SAFETY    OFF
  
  *-- DataBase Section
	  SET ANSI     OFF && = in SQL not equal to ==
	  SET DELETED  ON  && Deleted Rows Not Visible 
	  SET OPTIMIZE ON
  
  
  * Programming Section
  
  
  *-- Multiuser Section
	  SET AUTOSAVE   ON 
	  SET EXCLUSIVE  OFF
	  SET LOCK       ON
	  SET MULTILOCKS ON
	  set reprocess to 2
	  SET REFRESH    TO 10,20 && Display ,Local Buffer Increase Overhead and Network Traffic

  *-- Other Section
	  SET BELL OFF

  *-- Info Bar Section
	  *SET STATUS BAR ON
	  *SET CLOCK STATUS
	  SET STATUS BAR OFF
  
  *-- Information Support Structures Section
	  DO Support


  * INFO BASE BEGIN
   
   *-- Error Handler Settings
	   LOCAL M.EH_Active, m.nOpened
	   M.EH_Active = ON("ERROR")
	   m.nOpened = 0
	   on error iif( error()=1705,m.nOpened=1,m.nOpened=2)
      
   *-- Check if Checking Possible
	   if m.nOpened = 2
	      * errore bloccante 
	      quit
	   endif   
   
   *-- Error Handler Re-Settings
	   IF NOT EMPTY(M.EH_Active)
	      ON ERROR &EH_Active
	   ELSE
	      ON ERROR
	   ENDIF
   
    
   *-- Info Base Check and Fix
	   IF M.GS_IBCheck AND M.GS_ISSERVER and m.nOpened = 0

	      DO FORM InfoMsg.SCX WITH "Operazioni in corso ..."
	      
	      SET PATH TO (ALLTRIM(M.xi_IBPath))        
	      SET LIBRARY TO (M.GS_LRP+"FFIX4_50.FLL") ADDITIVE
	      
	      SELECT 01
	      USE      
	      IF NOT FixDBF(M.GS_LRP+"MEMORY.DBF",0)=0
	         =FixDBF(M.GS_LRP+"MEMORY.DBF",1)
	      ENDIF
	      USE (M.GS_LRP+"MEMORY.DBF") EXCLUSIVE      
	     * PACK MEMO DBF 


	      SELECT 02
	      USE      
	      IF NOT FixDBF(ALLTRIM(M.xi_IBPath)+"INFOBASE.DBC",0)=0
	         =FixDBF(ALLTRIM(M.xi_IBPath)+"INFOBASE.DBC",1)
	      ENDIF      

	      USE      
	      IF NOT FixDBF(ALLTRIM(M.xi_IBPath)+"USERS.DBF",0)=0
	         =FixDBF(ALLTRIM(M.xi_IBPath)+"USERS.DBF",1)
	      ENDIF      
	            
	      
	      IF NOT FixDBF(ALLTRIM(M.xi_IBPath)+"gmemory.DBF",0)=0
	         =FixDBF(ALLTRIM(M.xi_IBPath)+"gmemory.DBF",1)
	      ENDIF      

	      *- Category
	         if NOT FixDBF(ALLTRIM(M.xi_IBPath)+"category.DBF",0)=0 then
	            =FixDBF(ALLTRIM(M.xi_IBPath)+"category.DBF",1)
	         endif

        *- Classify
	         if NOT FixDBF(ALLTRIM(M.xi_IBPath)+"classify.DBF",0)=0 then
	            =FixDBF(ALLTRIM(M.xi_IBPath)+"classify.DBF",1)
	         Endif
	         
	      *- Contatti ed Eventi
	         if NOT FixDBF(ALLTRIM(M.xi_IBPath)+"contatto.DBF",0)=0 then
	            =FixDBF(ALLTRIM(M.xi_IBPath)+"contatto.DBF",1)
	         endif


	      *-- Release Resource 
		      RELEASE LIBRARY (M.GS_LRP+"FFIX4_50.FLL")
	      
	      *-- Data Base Container Rebuild    
		      DO SetInfoBase WITH M.xi_IBPath, .F.                
		      RELEASE WINDOWS InfoMsg
      
	   ENDIF

   * Error Handler Settings
*!*	   IF NOT EMPTY(M.EH_Active)
*!*	      ON ERROR &EH_Active
*!*	   ELSE
*!*	      ON ERROR
*!*	   ENDIF
  
 * Info Base Settings      
   OPEN DATABASE (ALLTRIM(M.xi_IBPath)+"INFOBASE.DBC") SHARED 
   
 *-- Base Entity Section
	 SELECT 01   
	 USE
	 USE (M.GS_LRP+"MEMORY.DBF") SHARED
	 =CURSORSETPROP("Buffering",5,"MEMORY")
		   
	 SELECT 02
	 USE
	 USE ( ALLTRIM(m.xi_IBPath)+"USERS.DBF" ) SHARED
	 =CURSORSETPROP("Buffering",5,"USERS")	   
	   
	 SELECT 03
	 USE
	 USE ( ALLTRIM(m.xi_IBPath)+"gmemory.DBF" ) SHARED
	 =CURSORSETPROP("Buffering",5,"gmemory")	   




 *-- Entity
	 SELECT 05
	 USE
	 USE ( ALLTRIM(m.xi_IBPath)+"category.dbf" ) SHARED
	 =CURSORSETPROP("Buffering",5,"category")	   

	 SELECT 06
	 USE
	 USE ( ALLTRIM(m.xi_IBPath)+"contatto.dbf" ) SHARED
	 =CURSORSETPROP("Buffering",5,"contatto")	   


	 SELECT 07
	 USE
	 USE ( ALLTRIM(m.xi_IBPath)+"cagenda.dbf" ) SHARED
	 =CURSORSETPROP("Buffering",5,"cagenda")	   


	 SELECT 08
	 USE
	 USE ( ALLTRIM(m.xi_IBPath)+"classify.dbf" ) SHARED
	 =CURSORSETPROP("Buffering",5,"classify")	   



     *-- from 200 to 255 services
     
* View Section

*
ENDPROC
*-------------------------------------------------------------------------------------------------------------------------------
PROCEDURE SetInfoBase
***
* Purpose  > Rebuild Info-Base and Index
***
* SECTION COMMUNICATION
LPARAMETERS M.xi_DBCPath, M.xi_OnlySet

* AREA INTELLIGENCE


IF NOT  M.GS_ISSERVER
   RETURN
ENDIF


* Settings
SET SAFETY OFF
SET TALK   OFF

* Error Handler Settings
LOCAL M.EH_Active, M.LocError
M.EH_Active = ON("ERROR")
ON ERROR DO SetErrorMonitor && M.LocError = .T.
  
*-- Work Area Initializing
	CLOSE TABLES ALL
	CLOSE DATABASES ALL
	CLOSE ALL
	FREE TABLE (ALLTRIM(M.xi_DBCPath)+"USERS.DBF")
	FREE TABLE (ALLTRIM(M.xi_DBCPath)+"gmemory.DBF")
	Free table (ALLTRIM(M.xi_DBCPath)+"category.DBF") 
	Free table (ALLTRIM(M.xi_DBCPath)+"classify.DBF") 
	Free table (ALLTRIM(M.xi_DBCPath)+"contatto.DBF") 
	Free table (ALLTRIM(M.xi_DBCPath)+"cagenda.DBF") 

	DELETE DATABASE (ALLTRIM(M.xi_DBCPath)+"INFOBASE.DBC")
	CREATE DATABASE (ALLTRIM(M.xi_DBCPath)+"INFOBASE.DBC")

	OPEN   DATABASE (ALLTRIM(M.xi_DBCPath)+"INFOBASE.DBC") EXCLUSIVE
	validate database

	SET    DATABASE TO (ALLTRIM(M.xi_DBCPath)+"INFOBASE.DBC")

	ADD TABLE (ALLTRIM(M.xi_DBCPath)+"USERS.DBF")
	ADD TABLE (ALLTRIM(M.xi_DBCPath)+"gmemory.DBF")
	ADD TABLE (ALLTRIM(M.xi_DBCPath)+"category.DBF")
	ADD TABLE (ALLTRIM(M.xi_DBCPath)+"classify.DBF")
	Add Table (ALLTRIM(M.xi_DBCPath)+"contatto.DBF")
	Add Table (ALLTRIM(M.xi_DBCPath)+"cagenda.DBF")
	pack database

*-- Logical and Referential Integrity
  


*-- Building InfoBase

    *-- Users
		SELECT 02
		USE (ALLTRIM(M.xi_DBCPath)+"USERS.DBF") EXCLUSIVE
		pack
		IF ( NOT M.xi_OnlySet ) OR ( INLIST(M.EM_NUMBER, 19, 144 ) ) 
		   INDEX ON UPPER(ALLTRIM(USERS.UNAME)) TAG USERNAME ASCENDING
		ENDIF

    *-- Global Memory
		SELECT 03
		USE (ALLTRIM(M.xi_DBCPath)+"gmemory.DBF") EXCLUSIVE
		pack
		IF ( NOT M.xi_OnlySet ) OR ( INLIST(M.EM_NUMBER, 19, 144 ) ) 
		*INDEX ON UPPER(ALLTRIM(TRIC.DSZ))   TAG ALFA ASCENDING
		ENDIF  

		  
    *-- Category
		SELECT 05
		USE (ALLTRIM(M.xi_DBCPath)+"category.DBF") EXCLUSIVE
		pack
		IF ( NOT M.xi_OnlySet ) OR ( INLIST(M.EM_NUMBER, 19, 144 ) ) then 
		   index on Upper(Alltrim(category.hcode))         tag hcode    ascending
		   index on Upper(Alltrim(category.hdesc))         tag hdesc    ascending
		endif



    *-- Contatto
		SELECT 06
		USE (ALLTRIM(M.xi_DBCPath)+"contatto.DBF") EXCLUSIVE
		pack
		IF ( NOT M.xi_OnlySet ) OR ( INLIST(M.EM_NUMBER, 19, 144 ) ) then 
	       index on contatto.cnt_ide                                                           TAG v0         ascending	
	  	   index on upper(alltrim(contatto.cognome))+upper(alltrim(contatto.nome))             TAG v1         ascending		
	  	   index on upper(alltrim(contatto.ente))                                              TAG v2         ascending	
		endif

    *-- Activity
		SELECT 07
		USE (ALLTRIM(M.xi_DBCPath)+"cagenda.DBF") EXCLUSIVE
		pack
		IF ( NOT M.xi_OnlySet ) OR ( INLIST(M.EM_NUMBER, 19, 144 ) ) then 
	       index on cagenda.cnt_rif                                                          TAG v0         ascending	
	  	   index on Ttoc(cagenda.when,1)                                                     TAG v1         ascending		
	  	   index on Dtoc(Ttod(cagenda.when),1)                                               TAG v2         ascending
		endif

   *-- Classe
		SELECT 08
		USE (ALLTRIM(M.xi_DBCPath)+"classify.DBF") EXCLUSIVE
		pack
		IF ( NOT M.xi_OnlySet ) OR ( INLIST(M.EM_NUMBER, 19, 144 ) ) then 
		   index on Upper(Alltrim(classify.hcode))         tag hcode    ascending
		   index on Upper(Alltrim(classify.hdesc))         tag hdesc    ascending
		endif
	  	
* View Section

*-- Physical Integrity
	VALIDATE DATABASE
	CLOSE TABLES
	PACK DATABASE
	CLOSE DATABASE
	COPY FILE (ALLTRIM(M.xi_DBCPath)+"INFOBASE.DCX") TO (M.xi_DBCPath+"IBBK.DCX") 
	COPY FILE (ALLTRIM(M.xi_DBCPath)+"INFOBASE.DCT") TO (M.xi_DBCPath+"IBBK.DCT") 
	COPY FILE (ALLTRIM(M.xi_DBCPath)+"INFOBASE.DBC") TO (M.xi_DBCPath+"IBBK.DBC") 

* Error Handler Settings
*!*	IF NOT EMPTY(M.EH_Active)
*!*	   ON ERROR &EH_Active
*!*	ELSE
*!*	   ON ERROR
*!*	ENDIF

endproc

*-----------------------------------------------------------------------------------------------------------------------------
PROCEDURE DBMCT
*--
* PURPOSE > Dynamic Bar Menu and Context Menu Component Technology.
*
*--
*-- SECTION COMMUNICATION
	LPARAMETERS M.ii_Context, M.ii_StatusContext
	* M.ii_Context       : BASE_CONTEXT
	* M.ii_StatusContext :

*-- AREA INTELLIGENCE
		DO CASE
		   CASE M.ii_Context=="BASE_CONTEXT"
		        if upper(alltrim(m.gs_ruolo)) == "AMMINISTRATORE"
		           DO MENU00.MPR
		        else
		           DO MENU01User.MPR
		        endif   
		        DO MENU02.MPR
		        DO MENU08.MPR    
		        DO MENU09.MPR    
		        DO MENU11.MPR    

		   CASE M.ii_Context=="BASE_BASE"
		        if upper(alltrim(m.gs_ruolo)) == "AMMINISTRATORE"
		           DO MENU01.MPR
		        else
		           DO MENU01User.MPR
		        endif   
		        DO MENU02.MPR
		        
		   CASE M.ii_Context=="NULL"        
		        DO MENUNULL.MPR
		        
		   OTHERWISE
		             
		ENDCASE

*-- Indicatore Stazione di Lavoro

*
ENDPROC
*-----------------------------------------------------------------------------------------------------------------------------
PROCEDURE Support
*---
* Purpose  >  Creation of support information structure
*---


*-- Year Month
    Public Array YearMonth[12] 
    YearMonth[01] = "Gennaio   "
    YearMonth[02] = "Febbraio  "
    YearMonth[03] = "Marzo     "
    YearMonth[04] = "Aprile    "
    YearMonth[05] = "Maggio    "
    YearMonth[06] = "Giugno    "
    YearMonth[07] = "Luglio    "
    YearMonth[08] = "Agosto    "
    YearMonth[09] = "Settembre "
    YearMonth[10] = "Ottobre   "
    YearMonth[11] = "Novembre  "
    YearMonth[12] = "Dicembre  "
     

*-- Priority
    Public Array Priority[101]
    Priority[001]="000" 
    For j=2 To 101 Step 1
        Priority[j]=Transform(j-1,"@L 999")
    Endfor
    

*-- Work Type
Endproc

*-----------------------------------------------------------------------------------------------------------------------------
PROCEDURE SetErrorMonitor

M.EM_NUMBER = ERROR()
M.EM_MSG    = MESSAGE()

*!*	WAIT WINDOW M.EM_MSG+"/ "+ALLTRIM(STR(M.EM_NUMBER)) TIMEOUT 0.8

ENDPROC
*-----------------------------------------------------------------------------------------------------------------------------
*-----------------------------------------------------------------------------------------------------------------------------
function GetShortPostoFunzione(m.xiPPCode as Integer) as String
   
   select profilo
   set filter to
   locate for profilo.ppcode = m.xiPPCode
   if not found("profilo") then
      return ""
   else
      return alltrim(profilo.pfdescsh)     
   endif
   
endfunc
*-----------------------------------------------------------------------------------------------------------------------------
FUNCTION ShellExec
LPARAMETER lcLink, lcAction, lcParms

lcAction = IIF(EMPTY(lcAction), "Open", lcAction)
lcParms = IIF(EMPTY(lcParms), "", lcParms)

DECLARE INTEGER ShellExecute ;
    IN SHELL32.dll ;
    INTEGER nWinHandle, ;
    STRING cOperation, ;
    STRING cFileName, ;
    STRING cParameters, ;
    STRING cDirectory, ;
    INTEGER nShowWindow

DECLARE INTEGER FindWindow ;
   IN WIN32API ;
   STRING cNull,STRING cWinName

RETURN ShellExecute(FindWindow(0, _SCREEN.caption), ;
                    lcAction, lcLink, ;
                    lcParms, SYS(2023), 1)
*-----------------------------------------------------------------------------------------------------------------------------
*-----------------------------------------------------------------------------------------------------------------------------
function GetCard ()
*---
* Output   > ID Card : if Card selected.
*                  0 : otherwise
*
* Purpose  > selecting a card
*---

*-- section service
    public m.rLInk   as String
    public m.rCarica as String


    
    public m.rInfoBack
    
    
    public m.xFeedBack       
    m.xFeedBack = 0    
    * 0 = Nessuna Selezione
    * 1 = Selezionato un Sinistro
    * 2 = Ricerca

*-- area intelligence
    m.rLink         = ""  
    m.rCarica       = ""
    m.rInfoBack     = ""
    m.RandomFolder = alltrim(substr(sys(2015),2))
   
       
    public m.LQRS
    m.LQRS = m.GS_LRP+"cache\"+alltrim(m.RandomFolder)+"\"  
    
     =MKDIR(JUSTPATH(ALLTRIM(m.LQRS)))

	if used("qrs") then
	   select qrs
	   use
	endif    
	
    create table (alltrim(m.LQRS)+"qrs.dbf") free ;
       ( cnt_ide     N(010), ;
         cognome     C(040), ;
         nome        C(040), ;
         carica      C(100)  )
 
    select qrs
    append blank    
    

    do while .t.
      
       do form usm_ricercacard.scx 
        
        
       do case
          case m.xFeedBack = 0
               exit
               
          case m.xFeedBack = 1
               exit

          case m.xFeedBack = 2
               loop
               
       endcase
       
    enddo    
     
    if m.xFeedBack = 1 then
       local m.ID_crd
       m.ID_crd=qrs.cnt_ide
       
	   *-- Garbage Collector della Ricerca Scheda
		   if used("qrs")
			  select qrs
			  use
		   endif  
		        		   
       return m.ID_crd
       
    else
    
	   *-- Garbage Collector della Ricerca Scheda
		   if used("qrs")
			  select qrs
			  use
		   endif  
		            
       return 0
    endif   
     
endfunc

*-----------------------------------------------------------------------------------------------------------------------------
*-----------------------------------------------------------------------------------------------------------------------------
function GetReg ()
*---
* Output   > recno    : if Reg is selected.
*                   0 : otherwise
*
* Purpose  > selecting a reg. 
*---

*-- section service
    public m.rLInk   as String
    public m.rCarica as String


    
    public m.rInfoBack
    
    
    public m.xFeedBack       
    m.xFeedBack = 0    
    * 0 = Nessuna Selezione
    * 1 = Selezionato un Sinistro
    * 2 = Ricerca

*-- area intelligence
    m.rLink         = ""  
    m.rCarica       = ""
    m.rInfoBack     = ""
    m.RandomFolder = alltrim(substr(sys(2015),2))
   
       
    public m.LQRS
    m.LQRS = m.GS_LRP+"cache\"+alltrim(m.RandomFolder)+"\"  
    
     =MKDIR(JUSTPATH(ALLTRIM(m.LQRS)))

	if used("qrs") then
	   select qrs
	   use
	endif    
	
	
	
	
	
	
    create table (alltrim(m.LQRS)+"qreg.dbf") free ;
       ( reg_ide     N(010), ;
         titolo      C(060), ;
         cognome     C(040), ;
         nome        C(040), ;
         from        C(040), ;
         when        T,      ;
         forwhat     C(254), ;
         fordesc     M,      ;
         carica      C(100)  )
 
    select qreg
    append blank    
    
    
    
    

    do while .t.
      
       do form usm_ricercareg.scx 
        
        
       do case
          case m.xFeedBack = 0
               exit
               
          case m.xFeedBack = 1
               exit

          case m.xFeedBack = 2
               loop
               
       endcase
       
    enddo    
     
    if m.xFeedBack = 1 then
       local m.ID_reg
       m.ID_reg=contatto.cnt_ide
       
	   *-- Garbage Collector della Ricerca Scheda
		   if used("qrs")
			  select qrs
			  use
		   endif  
		        		   
       return m.ID_snst
       
    else
    
	   *-- Garbage Collector della Ricerca Scheda
		   if used("qrs")
			  select qrs
			  use
		   endif  
		            
       return 0
    endif   
     
endfunc

*-----------------------------------------------------------------------------------------------------------------------------

