
*--------------------------------------------------------------------
* Report Wrapper Class
*
* Purpose    > It provides Methods for the report handling
*
* Properties >
*
* Methods    >
*--------------------------------------------------------------------
define class report as custom

*- Space Service 
   protected m.lCancel

*- Space Properties
   cReport       = ""
   cDynaTitle    = ""
   cHeaderLabel  = ""
   cFooterLabel  = ""
   nPages        = 0
   lPrinted      = .f.

*- Space Methods

*-- Print the report
    procedure Print
      this.Report("to print prompt noconsole")
    endproc    

*-- Preview the Report
    procedure Preview
      this.Report("Preview")
    endproc

*-- Determine the total number of pages in the report
*   Technology > page x of y - write to file before 
    procedure TotalPages
      this.WriteToFile(sys(3)+".tmp",.t.)
      this.nPages = _pageno
    endproc

*-- Write a Report to File
    procedure WriteToFile 
    *--
    * input > tcFile  : name of report file
    *         tlErase : erase the file after printing
    *--
      lparameters m.tcFile, m.tlErase
      
      *- Assertions
         assert PCount() >= 1
         assert type("m.tcFile")  == "C"
         assert type("m.tlErase") == "L"      
      *- Send a Report to a File
         this.Report([to File "]+m.tcFile+[" noconsole])
         if  m.tlErase ;
         and file(m.tcFile)
             erase m.tcFile
         endif
    endproc

*-- Issues the Report command using options defined in m.tcOption
    procedure Report
    lparameters m.tcOption
    
    with this
      *- Assertions
         assert PCount()            == 1
         assert type("m.tcOption") == "C" 

      *- Issue the Report Command. We clear the keyboard buffer afterwards,
      *  in case we tried to cancel the report, but VFP terminated printing
      *  before processing the key stroke.
         private m.poThis 
         m.poThis  = this
         .lPrinted = .f.
         .lCancel  = .f.
         report form (.cReport) &tcOption
         clear typeahead
    endwith

    endproc

*-- This method is called by the report when the summary band is exited.
*   We set the lPrinted flag and release the progress window.
    procedure OnExitSummary
      if wexist("Printing...")
         this.lPrinted = .t.
      endif
    endproc

enddefine
*--------------------------------------------------------------------


