* Versione  1.0  - Rilasciata il
* Revisione 1.0  - Rilasciata il
*

*------------------------------------------------------------------------------
FUNCTION GetUIN
* Unique Identification Number 

* SECTION COMMUNICATION

* SECTION SERVICE
LOCAL M.xWSName, M.xDate, M.xSeconds, M.xRandom, M.xGUIN

WAIT WINDOW " Generazione Codice Univoco in corso ... " TIMEOUT 0.2

M.xWSName  = ALLTRIM(TRANSFORM(MEMORY.WSNAME,"@L 99"))              && 02
M.xDate    = ALLTRIM(DTOC(DATE(),1))                                && 08
M.xSeconds = ALLTRIM(STRTRAN(STR(SECONDS(),10,3),".",""))           && 08
*M.xRandom  = ALLTRIM(RIGHT(SYS(2),4))                              && 04

M.GUIN = VAL( M.xWSName-M.xDate-M.xSeconds )
*
RETURN M.GUIN
ENDFUNC

*------------------------------------------------------------------------------
FUNCTION Random
*--
* Purpose > generate a random number between M.xi_LowValue, M.xi_HigthValue
*--
LPARAMETERS M.xi_LowValue, M.xi_HigthValue

RETURN INT( (RAND()*(M.xi_HigthValue-M.xi_LowValue+1))+M.xi_LowValue )
ENDFUNC
*------------------------------------------------------------------------------
FUNCTION RunDOS (M.xiCmdDOS)
*---
* Input   > M.xiCmdDOS : Comando DOS da eseguire.
* Output  > .T.        : Comando Eseguito con successo
*           .F.        : Comando NON Eseguito con successo    
* Purpose > Esegue un comando DOS.
*---

* SECTION SERVICE
  
  * COSTANTS
  #DEFINE DOS_Limit 127

* AREA INTELLIGENCE
  IF LEN(M.xiCmdDOS) > DOS_Limit
     RETURN .F.
  ELSE
     RUN /N &xiCmdDOS
  ENDIF

ENDFUNC


*------------------------------------------------------------------------------
FUNCTION GetHumanAge (M.xiBirthDate)
*---
* Input   > M.xiBirthDate : 
* Output  > 99            : person's Age
* Purpose > Returning a Person's Age Based on Today's Date.
*---

* SECTION SERVICE
  
  * COSTANTS
  
  * VARIABLES
  LOCAL M.InAge 
  
*-- AREA INTELLIGENCE
	M.InAge = YEAR(DATE()) - YEAR(M.xiBirthDate)
	IF CTOD(LEFT(DTOC(DATE()),6)+"00") < CTOD(LEFT(DTOC(M.xiBirthDate),6)+"00") then
	   M.InAge=M.InAge+1
	ENDIF
RETURN M.InAge
*
ENDFUNC
*-------------------------------------------------------------------------------------------------------------------------
FUNCTION GetWeekDay (m.xiWDate as Date )

*-- Check Parameters Passed
	IF NOT TYPE("M.xiWDate") == "D"
	   RETURN ""
	ENDIF

*-- SECTION SERVICE
	LOCAL M.EWeekDay,  M.xo_WeekLabel
	M.EWeekDay      =UPPER(ALLTRIM(CDOW(M.xiWDate)))
	M.xo_WeekLabel = ""
	
*-- AREA INTELLIGENCE
	DO CASE
	   CASE M.EWeekDay == "SUNDAY"
	        M.xo_WeekLabel = "Domenica"
	        
	   CASE M.EWeekDay == "MONDAY"
	        M.xo_WeekLabel = "Luned"
	        
	   CASE M.EWeekDay == "TUESDAY"
	        M.xo_WeekLabel = "Marted"
	        
	   CASE M.EWeekDay == "WEDNESDAY"
	        M.xo_WeekLabel = "Mercoled"
	        
	   CASE M.EWeekDay == "THURSDAY"
	        M.xo_WeekLabel = "Gioved"
	        
	   CASE M.EWeekDay == "FRIDAY"
	        M.xo_WeekLabel = "Venerd"
	        
	   CASE M.EWeekDay == "SATURDAY"
	        M.xo_WeekLabel = "Sabato"
	ENDCASE
*
RETURN  M.xo_WeekLabel

Endfunc
*.......................................................................................................................................................
Function IsHoliday ( m.UnaData as Date ) as Boolean


*-- Check Parameters Passed
	If NOT TYPE("m.UnaData") == "D" then
	   Return .f.
	Endif
	

*-- Section Service
    Local m.EWeekDay as String    
	m.EWeekDay      =UPPER(ALLTRIM(CDOW(m.UnaData)))

*-- area intelligence
    If ( m.EWeekDay == "SATURDAY" ) Or ( m.EWeekDay == "SUNDAY" ) then
       Return .t.
    endif
    
    *-- Natale e Santo Stefano
        If Inlist(Day(m.UnaData),25,26) And Month(m.UnaData) = 12 then
           Return .t.
        Endif

    *-- Ferragosto
        If Inlist(Day(m.UnaData),15) And Month(m.UnaData) = 08 then
           Return .t.
        Endif
        
    *...   
     
    Return .f.
Endfunc

*.......................................................................................................................................................

FUNCTION GetMonthLabel
* SECTION COMMUNICATION
LPARAMETER M.MonthNumer

* AREA INTELLIGENCE
  DO Case 
  
     CASE M.MonthNumer=1
          RETURN "Gennaio"
     CASE M.MonthNumer=2
          RETURN "Febbraio"
     CASE M.MonthNumer=3
          RETURN "Marzo"
     CASE M.MonthNumer=4
          RETURN "Aprile"
     CASE M.MonthNumer=5
          RETURN "Maggio"
     CASE M.MonthNumer=6
          RETURN "Giugno"
     CASE M.MonthNumer=7
          RETURN "Luglio"
     CASE M.MonthNumer=8
          RETURN "Agosto"
     CASE M.MonthNumer=9
          RETURN "Settembre"
     CASE M.MonthNumer=10
          RETURN "Ottobre"
     CASE M.MonthNumer=11
          RETURN "Novembre"
     CASE M.MonthNumer=12
          RETURN "Dicembre"
          
  Endcase
  
*
RETURN ""
ENDFUNC
*--------------------------------------------------------------------------------------------------------------------------------------------------------
FUNCTION GetDaysOfMonth ( m.xiAnno, m.MonthNumer )

*-- AREA INTELLIGENCE
	DO CASE
	   CASE M.MonthNumer=1
	        RETURN 31
	   CASE M.MonthNumer=2
	        IF MOD(m.xiAnno,4)=0 then
	           RETURN 29
	        ELSE
	           RETURN 28
	        ENDIF
	   CASE M.MonthNumer=3
	        RETURN 31
	   CASE M.MonthNumer=4
	        RETURN 30
	   CASE M.MonthNumer=5
	        RETURN 31
	   CASE M.MonthNumer=6
	        RETURN 30
	   CASE M.MonthNumer=7
	        RETURN 31
	   CASE M.MonthNumer=8
	        RETURN 31
	   CASE M.MonthNumer=9
	        RETURN 30
	   CASE M.MonthNumer=10
	        RETURN 31
	   CASE M.MonthNumer=11
	        RETURN 30
	   CASE M.MonthNumer=12
	        RETURN 31
    Endcase
    
*
RETURN 0
Endfunc

*--------------------------------------------------------------------------------------------------------------------------------------------------------
FUNCTION GetItemPosition ( xiArray, M.xiItem )
***
* Purpose > Determina la posizione fisica di un Item in un Array
***

* SECTION SERVICE
LOCAL M.J_Item, M.J_Row
M.J_Item = 0
M.J_Row  = 0

* AREA INTELLIGENCE
M.J_Item = ASCAN(xiArray,M.xiItem)

*
RETURN IIF(M.J_Item=0,0,ASUBSCRIPT(xiArray,M.J_Item,1))

ENDFUNC
*------------------------------------------------------------------------------------------------------------------------------------------
procedure GetAPIEnv
*---
* Input   > 
* Output  > 
* Purpose > Set up the Environment for accessing to Operating System Services.
* Logic   >
*---

*-- area service
    public e_hndWindow as Integer
    public e_cAction   as String
    public e_cFileName as String
    public e_cParams   as String
    public e_cDir      as String
    public e_nShowWin  as Integer

    e_hndWindow = 0  && Window Handle
    e_cAction   = "" && Action 
    e_cFileName = ""
    e_cParams   = ""
    e_cDir      = ""
    e_nShowWin  = ""

*-- ShellExecute: to invoke an external application    
	DECLARE INTEGER  ShellExecute           IN shell32.dll ; 
				     INTEGER e_hndWindow,    ;
					 STRING  e_cAction,      ;
					 STRING  e_cFileName,    ;
					 STRING  e_cParams,      ;
					 STRING  e_cDir,         ;
					 INTEGER e_nShowWin
*--
	 *cFileName = "c:\@ise\cache\test.xls"
	 *cParams   = "c:\@ise\cache"
	 *cAction = "open"
	* =ShellExecute(0,cAction,cFileName,cParams,"",1)	    
  

    DECLARE INTEGER GetActiveWindow IN win32api

endproc
*------------------------------------------------------------------------------------------------------------------------------------------
FUNCTION GetFromHumanAge (m.xiBirthDate, m.xiFrom )
*---
* Input   > M.xiBirthDate : 
* Output  > 99            : person's Age
* Purpose > Returning a Person's Age Based on a Specified Date.
*---

*-- SECTION SERVICE
  
  *-- COSTANTS
  
  *-- VARIABLES
      LOCAL M.InAge 
      
      local m.BDate as Date
      m.BDate = {}
      
      local m.EDate as Date
      m.EDate = {}
  
*-- AREA INTELLIGENCE
	
	m.InAge = YEAR(m.xiFrom) - YEAR(M.xiBirthDate)
	
	m.BDate = ctod( ;
	                transform(day(M.xiBirthDate),"@L 99")+"/"+;
	                transform(month(M.xiBirthDate),"@L 99")+"/"+;
	                transform(year(m.xiFrom),"@L 9999") ;
	               )

   


	if m.BDate > m.xiFrom then
	   m.InAge=M.InAge-1
	endif

    if ( m.InAge >=65 ) then
	
		m.EDate = ctod( ;
		                transform(day(m.xiFrom),"@L 99")+"/"+;
		                transform(month(m.xiFrom),"@L 99")+"/"+;
		                transform(year(m.xiFrom)+2,"@L 9999") ;
		               )
		m.BDate = ctod( ;
		                transform(day(M.xiBirthDate),"@L 99")+"/"+;
		                transform(month(M.xiBirthDate),"@L 99")+"/"+;
		                transform(year(m.xiFrom)+2,"@L 9999") ;
		               )
	   
	   if m.BDate < m.EDate then
	      m.InAge = 67
	   endif 
        	
    endif

RETURN M.InAge
*------------------------------------------------------------------------------------------------------------------------------------------
PROCEDURE SendViaWinExecOutlookExpress(tcReturn, tcTo, tcSubject, tcBody, tcCC, tcBCC)

*-- section service
	DECLARE INTEGER WinExec IN kernel32 ;
	    STRING lpCmdLine ,;
	    INTEGER uCmdShow

    LOCAL lcCommand, lcCRLF
    
*-- area intelligence

  
  TRY
    lcCRLF = "%0D%0A"
    lcCommand = ["C:\Programmi\Outlook Express\msimn.exe" /mailurl:mailto:] + tcTo + "?Subject=" + tcSubject + "&Body=" + STRTRAN(tcBody, CHR(13), lcCRLF)
   
    if TYPE("tcCC") = "C" then
      lcCommand = lcCommand + "&CC=" + tcCC
    endif
    
    if TYPE("tcBCC") = "C" then
      lcCommand = lcCommand + "&BCC=" + tcBCC
    endif
    
    if LEN(lcCommand) > 32766 then && should be 32768, but not on my system
      THROW "Mailto command is limited to 32768 bytes"
    endif
    WinExec(lcCommand, 1)

  CATCH TO loError
   
    tcReturn = [Error: ] + STR(loError.ERRORNO) + CHR(13) + ;
               [LineNo: ] + STR(loError.LINENO) + CHR(13) + ;
               [Message: ] + loError.MESSAGE + CHR(13) + ;
               [Procedure: ] + loError.PROCEDURE + CHR(13) + ;
               [Details: ] + loError.DETAILS + CHR(13) + ;
               [StackLevel: ] + STR(loError.STACKLEVEL) + CHR(13) + ;
               [LineContents: ] + loError.LINECONTENTS
  finally
  
    CLEAR DLLS "WinExec"
    
  endtry
  
ENDPROC
*-------------------------------------------------------------------------------------------------------------------------------
PROCEDURE SendViaOutlook(tcReturn, tcTo, tcSubject, tcBody, taFiles, tcCC, tcBCC, tlHTMLFormat, tnImportance, tlOpenEmail)
 
 LOCAL loOutlook, loItem, lnCountAttachments, loMapi
 
 TRY
  loOutlook = CREATEOBJECT("outlook.application")
  loMapi    = loOutLook.GetNameSpace("MAPI")
  loMapi.Logon()
  loItem    = loOutlook.CreateItem(0)
 
  WITH loItem  
       .Subject = tcSubject
       .TO = tcTo
       
	   IF tlHTMLFormat then
	    .HTMLBody = tcBody
	   ELSE
	    .Body = tcBody
	   endif
	   
	   IF TYPE("tcCC") = "C"
	    .CC = tcCC
	   endif
	   
	   IF TYPE("tcBCC") = "C"
	    .BCC = tcBCC
	   endif
	   
	   IF TYPE("tnImportance") != "N"
	    tnImportance = 1 && normal importance
	   endif
	   
	   .Importance = tnImportance
	   
		*!*		   IF TYPE("tafiles",1) = "A"
		*!*		    FOR lnCountAttachments = 1 TO ALEN(taFiles)
		*!*		     .Attachments.ADD(taFiles(lnCountAttachments))
		*!*		    ENDFOR
		*!*		   endif
	   
	   IF tlOpenEmail
	    .DISPLAY()
	   ELSE
	    .SEND()
	   ENDIF
  endwith
  
 CATCH TO loError
  tcReturn = [Error: ] + STR(loError.ERRORNO) + CHR(13) + ;
             [LineNo: ] + STR(loError.LINENO) + CHR(13) + ;
             [Message: ] + loError.MESSAGE + CHR(13) + ;
             [Procedure: ] + loError.PROCEDURE + CHR(13) + ;
             [Details: ] + loError.DETAILS + CHR(13) + ;
             [StackLevel: ] + STR(loError.STACKLEVEL) + CHR(13) + ;
             [LineContents: ] + loError.LINECONTENTS
 finally
 
  RELEASE oOutlook, oItem
  STORE .NULL. TO oOutlook, oItem
  
 endtry
 
endproc

*-------------------------------------------------------------------------------------------------------------------------------
FUNCTION ShellExec
LPARAMETER lcLink, lcAction, lcParms

lcAction = IIF(EMPTY(lcAction), "Open", lcAction)
lcParms = IIF(EMPTY(lcParms), "", lcParms)

DECLARE INTEGER ShellExecute ;
    IN SHELL32.dll ;
    INTEGER nWinHandle, ;
    STRING cOperation, ;
    STRING cFileName, ;
    STRING cParameters, ;
    STRING cDirectory, ;
    INTEGER nShowWindow

DECLARE INTEGER FindWindow ;
   IN WIN32API ;
   STRING cNull,STRING cWinName

RETURN ShellExecute(FindWindow(0, _SCREEN.caption), ;
                    lcAction, lcLink, ;
                    lcParms, SYS(2023), 1)
*-----------------------------------------------------------------------------------------------------------------------------
procedure GetAPIEnv
*---
* Input   > 
* Output  > 
* Purpose > Set up the Environment for accessing to Operating System Services.
* Logic   >
*---

*-- area service
    public e_hndWindow as Integer
    public e_cAction   as String
    public e_cFileName as String
    public e_cParams   as String
    public e_cDir      as String
    public e_nShowWin  as Integer

    e_hndWindow = 0  && Window Handle
    e_cAction   = "" && Action 
    e_cFileName = ""
    e_cParams   = ""
    e_cDir      = ""
    e_nShowWin  = ""

*-- ShellExecute: to invoke an external application    
	DECLARE INTEGER  ShellExecute           IN shell32.dll ; 
				     INTEGER e_hndWindow,    ;
					 STRING  e_cAction,      ;
					 STRING  e_cFileName,    ;
					 STRING  e_cParams,      ;
					 STRING  e_cDir,         ;
					 INTEGER e_nShowWin
*--
	 *cFileName = "c:\@ise\cache\test.xls"
	 *cParams   = "c:\@ise\cache"
	 *cAction = "open"
	* =ShellExecute(0,cAction,cFileName,cParams,"",1)	    
  

    DECLARE INTEGER GetActiveWindow IN win32api

Endproc
*-----------------------------------------------------------------------------------------------------------------------------
FUNCTION GoToURL(tcURL, tcAction, tcDirectory, tcParms)
 
*-- area intelligence
	IF EMPTY(tcUrl) Then 
	   RETURN -1
	Endif 

	IF EMPTY(tcAction) Then 
	   tcAction = "OPEN"
	ENDIF

	IF EMPTY(tcDirectory) Then 
	   tcDirectory = SYS(2023)
	ENDIF
	IF EMPTY(tcParms) then
	   tcParms = ""
	Endif 
	
	tcURL="http://"+Alltrim(tcURL)

	DECLARE INTEGER ShellExecute ;
	    IN SHELL32.dll ;
	    INTEGER nWinHandle,;
	    STRING  cOperation,;
	    STRING  cFileName,;
	    STRING  cParameters,;
	    STRING  cDirectory,;
	    INTEGER nShowWindow

	 

	DECLARE INTEGER FindWindow ;
	   IN WIN32API STRING cNull,STRING cWinName
	 

RETURN ShellExecute(FindWindow(0,_SCREEN.caption),;
                    tcAction,tcUrl,;
                    tcParms, tcDirectory,1)
*-----------------------------------------------------------------------------------------------------------------------------
