
*-----------------------------------------------------------------------------------------------------------------------------
procedure InsEvent(m.xiEvent)
*---
* Input    > m.xiEvent;
* Output   > 
*            
* Purpose  > insert data of empty event into Event set.
*---
    
*-- section service

*-- area intelligence
    *sis_event[01] = "Automatico      "    
    *sis_event[02] = "Manuale         "    
    *sis_event[03] = "Nota Automatica "    
    *sis_event[04] = "Nota Manuale    "    

    m.xiEvent = upper(alltrim(m.xiEvent))
    do case
    *- Nota : Caricamento Sinistro
       case m.xiEvent == "LOAD_SINISTRO"
            
            local m.SinDetails
            m.SinDetails = transform(sinistro.anno,"@L 9999")+" / "+ ;
                           alltrim(sinistro.agnz_cod)+" / "+alltrim(sinistro.numero)+space(05)
            if not len(alltrim(sinistro.ccodice)) = 0
	           m.SinDetails = m.SinDetails +"desk "+alltrim(sinistro.ccodice)
	        endif
       
		    select sinote		    
		    replace sinote.snst_rif     with sinistro.snst_cdc
		    replace sinote.ofwhom       with "Del Sinistro"
		    replace sinote.aevn_type    with sis_event[03]
		    replace sinote.awhen        with datetime()
		    replace sinote.afrom_prof   with m.gs_ruolo
		    replace sinote.afrom_user   with m.gs_username
            replace sinote.aevn_dsc     with "Caricamento Sinistro: "+m.SinDetails
            replace sinote.riferitoa    with m.gs_username
                        

    *- Nota : Informazione
       case m.xiEvent == "INFO_SINISTRO"
		    select sinote
		    replace sinote.snst_rif     with sinistro.snst_cdc
		    replace sinote.ofwhom       with "Del Sinistro"
		    replace sinote.aevn_type    with sis_event[03]
		    replace sinote.awhen        with datetime()
		    replace sinote.afrom_prof   with m.gs_ruolo
		    replace sinote.afrom_user   with m.gs_username
            replace sinote.aevn_dsc     with ""
            replace sinote.riferitoa    with m.gs_username

    *- Nota : Invio Documento
       case m.xiEvent == "SEND_DOC"
		    select sinote
		    replace sinote.snst_rif     with sinistro.snst_cdc
		    replace sinote.ofwhom       with "Del Sinistro"
		    replace sinote.aevn_type    with sis_event[03]
		    replace sinote.awhen        with datetime()
		    replace sinote.afrom_prof   with m.gs_ruolo
		    replace sinote.afrom_user   with m.gs_username
            replace sinote.aevn_dsc     with "Invio Documento"
            
            replace sinote.riferitoa    with m.gs_username
		    replace sinote.modcode      with modelli.modcode
            replace sinote.modname      with modelli.modname 
            replace sinote.scdata       with date()+modelli.scadenza
            replace sinote.scadenza     with modelli.scadenza
            replace sinote.avviso       with modelli.avviso


    *- Memo : Invio Quietanza CID o Non CID
       case m.xiEvent == "PRINT_QUIETANZA"
		    select sinote
		    replace sinote.snst_rif     with movconta.snst_rif
		    replace sinote.ofwhom       with "Del Sinistro"
		    replace sinote.aevn_type    with sis_event[03]
		    replace sinote.awhen        with datetime()
		    replace sinote.afrom_prof   with m.gs_ruolo
		    replace sinote.afrom_user   with m.gs_username
            replace sinote.aevn_dsc     with "Stampa Quietanza: "+alltrim(movconta.ass_benef)
            replace sinote.scadenza     with 20
            replace sinote.scdata       with ttod(sinote.awhen) + sinote.scadenza
            
            replace sinote.tsc_cod      with "QUI"
            replace sinote.tsc_dsc      with "Controllo RIENTRO QUIETANZA"
            replace sinote.tsc_cmpg     with movconta.cmpg_rif
            
            replace sinote.riferitoa    with m.gs_username
		    replace sinote.modcode      with ""
            replace sinote.modname      with ""

    *- Nota : Contenzioso Scadenza Preavviso
       case m.xiEvent == "CONTENZIOSO_SCADENZA_PREAVVISO"
            select sinote		    
		    replace sinote.snst_rif     with sinistro.snst_cdc
		    replace sinote.ofwhom       with "Del Sinistro"
		    replace sinote.aevn_type    with sis_event[03]
		    replace sinote.awhen        with datetime()
		    replace sinote.afrom_prof   with m.gs_ruolo
		    replace sinote.afrom_user   with m.gs_username
            replace sinote.aevn_dsc     with "Scadenza Contenzioso Data Preavviso"
            replace sinote.riferitoa    with m.gs_username
            replace sinote.scdata       with contenz.prea_data
                        

    *- Nota : Contenzioso Scadenza Prima Udienza
       case m.xiEvent == "CONTENZIOSO_SCADENZA_PRIMAUDIENZA"
            select sinote		    
		    replace sinote.snst_rif     with sinistro.snst_cdc
		    replace sinote.ofwhom       with "Del Sinistro"
		    replace sinote.aevn_type    with sis_event[03]
		    replace sinote.awhen        with datetime()
		    replace sinote.afrom_prof   with m.gs_ruolo
		    replace sinote.afrom_user   with m.gs_username
            replace sinote.aevn_dsc     with "Scadenza Contenzioso Data Prima Udienza"
            replace sinote.riferitoa    with m.gs_username
            replace sinote.scdata       with contenz.ud1_data           


    *- Nota Automatica : Caricamento Sinistro
       case m.xiEvent == "AUTOMATIC_LOAD_SINISTRO_EVENT"
            
            local m.SinDetails
            m.SinDetails = transform(sinistro.anno,"@L 9999")+" / "+ ;
                           alltrim(sinistro.agnz_cod)+" / "+alltrim(sinistro.numero)+space(05)
            if not len(alltrim(sinistro.ccodice)) = 0
	           m.SinDetails = m.SinDetails +"desk "+alltrim(sinistro.ccodice)
	        endif
       
		    select sinote		    
		    replace sinote.snst_rif     with sinistro.snst_cdc
		    replace sinote.ofwhom       with "Del Sinistro"
		    replace sinote.aevn_type    with sis_event[03]
		    replace sinote.awhen        with datetime()
		    replace sinote.afrom_prof   with m.gs_ruolo
		    replace sinote.afrom_user   with m.gs_username
            replace sinote.aevn_dsc     with "Caricamento Sinistro: "+m.SinDetails
            replace sinote.riferitoa    with m.gs_username


    endcase




endproc
*-----------------------------------------------------------------------------------------------------------------------------
procedure UpdateEventSet(m.xiEvent)
*---
* Input    > m.xiEvent;
* Output   > 
*            
* Purpose  > update Event Set.
*---
    
*-- section service

*-- area intelligence
    select memory
    go top
    
    select sinote
    use
    SELECT 62
    USE
    USE ( ALLTRIM(MEMORY.IBPATH)+"sinote.DBF" ) SHARED
    =CURSORSETPROP("Buffering",5,"sinote")
          
    begin transaction
    SELECT sinote
	SCATTER MEMVAR BLANK
	INSERT INTO sinote FROM MEMVAR
	
    select sinote
    replace sinote.evn_cdc with  val( transform(MEMORY.WSNAME,"@L 99")  +;
                                      alltrim(str(reccount("sinote"))) )+1000 
                                     
                                 
    
  	
*!*	     if flock("sinote")
*!*	        select sinote 
*!*	        local m.cKey, m.LastPgr
*!*	        m.cKey = recno("sinote")             
*!*	        
*!*	        select max(sinote.evn_cdc) as LastPgr ;
*!*	          from sinote ;
*!*	        into cursor xCursor
*!*	        
*!*	        if _tally = 0
*!*	           m.LastPgr = 1
*!*	        else
*!*	           m.LastPgr = xCursor.LastPgr+1
*!*	        endif   
*!*	        select sinote
*!*	        go m.cKey
*!*	        replace sinote.evn_cdc with m.LastPgr              
*!*	     else
*!*	        select sinote
*!*	        replace sinote.evn_cdc with reccount("sinote")+50
*!*	     endif    
	
    =InsEvent(m.xiEvent)
    
    *-- Store Data             
        LOCAL M.CIBStatus
        M.CIBStatus = TABLEUPDATE(1,.F.,"sinote")
        
        IF M.CIBStatus
           END TRANSACTION
           unlock all
        ELSE              
           rollback
           unlock all
           RETURN            
        ENDIF
    

endproc
*-----------------------------------------------------------------------------------------------------------------------------
procedure DelEvent()
*---
* Input    > m.xiEvent;
* Output   > 
*            
* Purpose  > Delete Current Event.
*---


*-- define section
    #DEFINE SUCCESS                 0
    #DEFINE FAIL                    1
  
*-- section service

*-- area intelligence
	LOCAL M.MsgForUser, M.UserAnswer
	M.MsgForUser = "Conferma l'eliminazione del'evento corrente ?"	               
	M.UserAnswer = FAIL
	DO FORM DECISION.SCX WITH M.MsgForUser TO M.UserAnswer
	IF M.UserAnswer = SUCCESS	   
	   * Check if delete is feasible
	   
	     begin transaction      
	      select sinote
	      delete
	      LOCAL M.CIBStatus && Change Information Base Status
	      M.CIBStatus =     TABLEUPDATE(1,.F.,"sinote")  
	      IF M.CIBStatus 
	         END TRANSACTION         
	         SELECT sinote
	         SKIP -1 IN sinote         
	      ELSE      
	         =MESSAGEBOX(;
	             "Eliminazione momentaneamente non possibile."+CHR(13)+;
	             "Riprovare pi tardi ...",;
	             0+48+0,;
	             "Attenzione !!!")
	         rollback         
	      ENDIF
	   
	ENDIF

endproc

*--------------------------------------------------------------------------------------------------------------------------
procedure PrintEvento (m.xiType as String, m.xiEvn_cdc as Integer)
*--
* m.xiType > "IMMEDIATE" : Stampa l'evento corrente 
*            "SELECT"    : Seleziona l'evento via select
*--

*-- section service
    local m.Etype
    m.Etype = ""
    
*-- area intelligence
    m.xReport = "r14_evento.frx"
    
    do case
       case upper(alltrim(m.xiType)) == "IMMEDIATE"
       
			*-- Event Type
			    if  upper(alltrim(sinote.ofwhom))=="DEL SINISTRO"			    
				    select sinistro
				    locate for sinistro.snst_cdc = sinote.snst_rif
				    if  found("sinistro")
				        *-- Compagnia e Anno Esercizio
				        	m.Etype= alltrim(compagnia.ragsoc)+" / "+transform(sinistro.anno,"@L 9999")+" / "           
				       
				        *-- Agenzia 	    
				        	m.Etype = m.Etype + alltrim(sinistro.agnz_cod)+" / "+alltrim(sinistro.numero)+space(05)
				            if not len(alltrim(sinistro.ccodice)) = 0
				               m.Etype = m.Etype+space(05)+"desk "+alltrim(sinistro.ccodice)+space(05)               
				            endif
				    else
				        m.Etype = ""        
					endif            
				else
				   m.Etype = "Dell'Agenda Personale di "+alltrim(sinote.ofuser)        
				endif	
       
       
            select sinote

			REPORT FORM (m.xReport) ;
			       ALL              ;
			       NOCONSOLE        ;
			       range 1,1        ;
			       PREVIEW            
			       
       case upper(alltrim(m.xiType)) == "SELECT"
       
			*-- Event Type			    
			    select *      ;
			      from sinote ;
			    where sinote.evn_cdc = m.xiEvn_cdc ;
			    into cursor csinote
			    if reccount("csinote")=0
			       return
			    endif
			    select csinote
			    go top   
			      
			    if  upper(alltrim(csinote.ofwhom))=="DEL SINISTRO"			    
				    select sinistro
				    locate for sinistro.snst_cdc = csinote.snst_rif
				    if  found("sinistro")
				        *-- Compagnia e Anno Esercizio
				        	m.Etype= alltrim(compagnia.ragsoc)+" / "+transform(sinistro.anno,"@L 9999")+" / "           
				       
				        *-- Agenzia 	    
				        	m.Etype = m.Etype + alltrim(sinistro.agnz_cod)+" / "+alltrim(sinistro.numero)+space(05)
				            if not len(alltrim(sinistro.ccodice)) = 0
				               m.Etype = m.Etype+space(05)+"desk "+alltrim(sinistro.ccodice)+space(05)               
				            endif
				    else
				        m.Etype = ""        
					endif            
				else
				   m.Etype = "Dell'Agenda Personale di "+alltrim(sinote.ofuser)        
				endif	
       
       
            select csinote
			REPORT FORM (m.xReport) ;
			       ALL              ;
			       NOCONSOLE        ;
			       range 1,1        ;
			       to printer prompt
			       *PREVIEW            

       case upper(alltrim(m.xiType)) == "CURRENT"
       
            *-- Get Status
                m.eCurrent = recno("sinote")
                
			*-- Event Type			    			      
			    if  upper(alltrim(sinote.ofwhom))=="DEL SINISTRO"			    
				    select sinistro
				    if seek(sinote.snst_rif,"sinistro","snst_cdc") then

				        *-- Compagnia e Anno Esercizio
				        	m.Etype= alltrim(compagnia.ragsoc)+" / "+transform(sinistro.anno,"@L 9999")+" / "           
				       
				        *-- Agenzia 	    
				        	m.Etype = m.Etype + alltrim(sinistro.agnz_cod)+" / "+alltrim(sinistro.numero)+space(05)
				            if not len(alltrim(sinistro.ccodice)) = 0
				               m.Etype = m.Etype+space(05)+"desk "+alltrim(sinistro.ccodice)+space(05)               
				            endif
				    else
				        m.Etype = ""        
					endif            
				else
				   m.Etype = "Dell'Agenda Personale di "+alltrim(sinote.ofuser)        
				endif	
       
       
            select sinote
			REPORT FORM (m.xReport)    ;
			       record  m.eCurrent  ;
			       NOCONSOLE           ;
			       range 1,1           ;
			       to printer prompt
			       *PREVIEW            

           
           if between(m.eCurrent,1,reccount("sinote")) then
              select sinote
              go m.eCurrent
           endif      
           
    endcase
    


endproc
*--------------------------------------------------------------------------------------------------------------------------
function FastInsEvent(m.xiEvent, m.xiEventDsc ) as Integer
*---
* Input    > m.xiEvent;
* Output   > 
*            
* Purpose  > insert data of empty event into Event set.
*---

	 begin transaction 
	 select sinote
	 append blank
     select sinote		    
     replace sinote.snst_rif     with sinistro.snst_cdc
     replace sinote.ofwhom       with "Del Sinistro"
     replace sinote.aevn_type    with sis_event[05] && Nota Veloce Manuale
     replace sinote.awhen        with datetime()
     replace sinote.afrom_prof   with m.gs_ruolo
     replace sinote.afrom_user   with m.gs_username
     replace sinote.aevn_dsc     with alltrim(m.xiEventDsc)
     replace sinote.riferitoa    with m.gs_username	 
     
     replace sinote.evn_cdc with  val( transform(MEMORY.WSNAME,"@L 99")  +;
                                      alltrim(str(reccount("sinote"))) )+1000          

    *-- Store Data             
        LOCAL M.CIBStatus
        M.CIBStatus = TABLEUPDATE(1,.F.,"sinote")
        
        IF M.CIBStatus
           END TRANSACTION
           return sinote.evn_cdc
        ELSE              
           rollback     
           return 0     
        ENDIF
         
 
endfunc
*--------------------------------------------------------------------------------------------------------------------------
    