

lparameters m.xiDocType, m.xiPbls_rif, m.xiProtocollo, m.xiData, m.xiDstPath, m.xiAction
*--
* Input  > m.xiDocType     : Tipo Documento
*          m.xiPbls_rif    : Codice Lista
*          m.xiProtocollo  : Codice Protocollo
*          m.xiData        : Data Stampa Documento
*          m.xiDstPath     : Destination Path
*          m.xiAction      : PREVIEW, PRINT
*--

*-- area service
    local m.dm_DstDocName as String
    m.dm_DstDocName = ""
    
    local m.pp_epublist as Integer
    local m.pp_tdomanda as Integer
    local m.pp_trlist   as Integer
    local m.pp_anag     as Integer
    
    m.pp_epublist = recno("epublist")
    m.pp_tdomanda = recno("tdomanda")
    m.pp_trlist   = recno("trlist")
    m.pp_anag     = recno("anag")
   
   local m.pf_maturato as String
   m.pf_maturato = ""
*-- Source Entity Set-Up
    
    

    select epublist
    locate for epublist.pbls_ide = m.xiPbls_rif
    if not found("epublist") then
       return
    endif
    
    
    select tdomanda
    set filter to
    locate for tdomanda.pbls_rif   = m.xiPbls_rif  ;
           and tdomanda.protocollo = m.xiProtocollo
    if not found("tdomanda") then
       *wait window "Domanda non presente !" 
       return
    endif
    
    select trlist 
    set filter to
    locate for trlist.pbls_rif = m.xiPbls_rif ;
           and trlist.a_proto  = m.xiProtocollo
    if not found("trlist") then
       *wait window "Posto Non Presente !" 
       return
    endif
    
    select anag
    locate for anag.matricola = tdomanda.matricola
    if not found("anag") then
       *wait window "Anagrafica non presente !" 
       return
    endif
    
    select profilo
    locate for profilo.ppcode = anag.pprofilo
    if not found("profilo") then
       *wait window "Profilo non presente !" 
       return
    endif
    
    

*-- Doc Name
    m.tCognome = alltrim(tdomanda.cognome)
    m.tCognome = strtran(m.tCognome," ","_")   
    m.dm_DstDocName = alltrim(m.xiDstPath)+alltrim(tdomanda.qualifica)+"_"+m.tCognome+".doc"
    
*-- Model Creation
    do case
       case upper(alltrim(m.xiDocType)) == "COMUNICAZIONE"
           
           *-- ESTERO/MAE           
	           do case
	           *- MAE
	              case upper(alltrim(tdomanda.em))=="M"
	                   
	                   *-- CORSO CIFRA/NO CORSO CIFRA
		                   do case
		                   *- Posto Cifra ma Candidato senza Abilitazione Cifra 
		                      case ( trlist.pst_cifra = 1 ) and ( tdomanda.curr12 = 0 )
		                           
		                           *-- APPARTENENZA/MATURATO
			                            do case
							            *- Assegnati con Maturato
							               case ( trlist.ppcode = tdomanda.pm_code1 ) ;
							                 or ( trlist.ppcode = tdomanda.pm_code2 ) 
							                     
							                     *wait window "1. "+ m.dm_DstDocName
							                     copy file (alltrim(memory.modpath)+"com_mae_estero_sicfr_mat.doc") to (m.dm_DstDocName)
							                     
							                     do case
							                        case trlist.ppcode = tdomanda.pm_code1
							                             m.pf_maturato = tdomanda.pm_dsz1 
							                              
							                        case trlist.ppcode = tdomanda.pm_code2
							                             m.pf_maturato = tdomanda.pm_dsz2
							                               
							                        otherwise
							                             m.pf_maturato = "?"							                             
							                     endcase
							                     
							                     
			                               otherwise
			                                     *wait window "2. "+ m.dm_DstDocName
							                     copy file (alltrim(memory.modpath)+"com_mae_estero_sicfr_app.doc") to (m.dm_DstDocName)
			                            endcase		
			                                                 
		                   *- Posto Cifra ma Candidato con Abilitazione Cifra 
		                   *  Posto in cui non  Richiesta Abilitazione Cifra		                   
		                      otherwise
		                      
		                           *-- APPARTENENZA/MATURATO
			                            do case
							            *- Assegnati con Maturato
							               case ( trlist.ppcode = tdomanda.pm_code1 ) ;
							                 or ( trlist.ppcode = tdomanda.pm_code2 ) 
							                    
							                     *wait window "3. "+ m.dm_DstDocName
							                     copy file (alltrim(memory.modpath)+"com_mae_estero_nocfr_mat.doc") to (m.dm_DstDocName)
							                     
							                     do case
							                        case trlist.ppcode = tdomanda.pm_code1
							                             m.pf_maturato = tdomanda.pm_dsz1 
							                              
							                        case trlist.ppcode = tdomanda.pm_code2
							                             m.pf_maturato = tdomanda.pm_dsz2
							                               
							                        otherwise
							                             m.pf_maturato = "?"							                             
							                     endcase
							                     
			                               otherwise
			                                     *wait window "4. "+ m.dm_DstDocName
							                     copy file (alltrim(memory.modpath)+"com_mae_estero_nocfr_app.doc") to (m.dm_DstDocName)
			                            endcase		                     
		                      
		                      
		                   endcase
	           
	           
	           *- Estero
	              case upper(alltrim(tdomanda.em))=="E"
	              
	                   *-- CORSO CIFRA/NO CORSO CIFRA
		                   do case
		                   *- Posto Cifra ma Candidato senza Abilitazione Cifra 
		                      case ( trlist.pst_cifra = 1 ) and ( tdomanda.curr12 = 0 )
		                           
		                           *-- APPARTENENZA/MATURATO
			                            do case
							            *- Assegnati con Maturato
							               case ( trlist.ppcode = tdomanda.pm_code1 ) ;
							                 or ( trlist.ppcode = tdomanda.pm_code2 ) 
							                     copy file (alltrim(memory.modpath)+"com_estero_estero_sicfr_mat.doc") to (m.dm_DstDocName)
							                     do case
							                        case trlist.ppcode = tdomanda.pm_code1
							                             m.pf_maturato = tdomanda.pm_dsz1 
							                              
							                        case trlist.ppcode = tdomanda.pm_code2
							                             m.pf_maturato = tdomanda.pm_dsz2
							                               
							                        otherwise
							                             m.pf_maturato = "?"							                             
							                     endcase
							                     
			                               otherwise
							                     copy file (alltrim(memory.modpath)+"com_estero_estero_sicfr_app.doc") to (m.dm_DstDocName)
			                            endcase		                     
		                   *- Posto Cifra ma Candidato con Abilitazione Cifra 
		                   *  Posto in cui non  Richiesta Abilitazione Cifra		                   
		                      otherwise
		                      
		                           *-- APPARTENENZA/MATURATO
			                            do case
							            *- Assegnati con Maturato
							               case ( trlist.ppcode = tdomanda.pm_code1 ) ;
							                 or ( trlist.ppcode = tdomanda.pm_code2 ) 
							                     copy file (alltrim(memory.modpath)+"com_estero_estero_nocfr_mat.doc") to (m.dm_DstDocName)
							                     do case
							                        case trlist.ppcode = tdomanda.pm_code1
							                             m.pf_maturato = tdomanda.pm_dsz1 
							                              
							                        case trlist.ppcode = tdomanda.pm_code2
							                             m.pf_maturato = tdomanda.pm_dsz2
							                               
							                        otherwise
							                             m.pf_maturato = "?"							                             
							                     endcase
							                     
			                               otherwise
							                     copy file (alltrim(memory.modpath)+"com_estero_estero_nocfr_app.doc") to (m.dm_DstDocName)
			                            endcase		                     
		                      
		                      
		                   endcase
	              otherwise
	                   return
	           endcase

    
       case upper(alltrim(m.xiDocType)) == "DECRETO"
           
            do case
            *- Posto Cifra ma Candidato senza Abilitazione Cifra
               case ( trlist.pst_cifra = 1 ) and ( tdomanda.curr12 = 0 )
                    copy file (alltrim(memory.modpath)+"ls_dec_abil_cifra.doc") to (m.dm_DstDocName)
                    
            *- Assegnati con Maturato
               case ( trlist.ppcode = tdomanda.pm_code1 ) ;
                 or ( trlist.ppcode = tdomanda.pm_code2 ) 
                    
                    do case
                    *- Maturato Posto Economico Finanziario
                       case  ( trlist.ppcode = 161 )  ;
                         or  ( trlist.ppcode = 127 )  ;
                         or  ( trlist.ppcode = 134 )  
                             copy file (alltrim(memory.modpath)+"ls_dec_ecfin_mat.doc") to (m.dm_DstDocName)
                             
                    *- Normale
                       otherwise
                             copy file (alltrim(memory.modpath)+"ls_dec_nor_mat.doc") to (m.dm_DstDocName)
                    endcase                             

            *- Posto Economico Finanziario
               case inlist(trlist.ppcode,161,127,134) 
                    copy file (alltrim(memory.modpath)+"ls_dec_ecfin_app.doc") to (m.dm_DstDocName)
                            
               otherwise
		            copy file (alltrim(memory.modpath)+"ls_dec_nor_app.doc") to (m.dm_DstDocName)
		                   
            endcase
           
             
    endcase

    *wait window "5. "+ m.dm_DstDocName
    
*-- Document Creation
    local oWordObj as Object
    oWordObj = CreateObject("Word.Application")
    oWordObj.visible = .t.
    oWordObj.Documents.Open(m.dm_DstDocName) 
    
    
    *-- Getting BookMarks
        m.dm_CountMarks = oWordObj.ActiveDocument.BookMarks.Count
        if m.dm_CountMarks = 0 then
           m.dm_CountMarks = 1
        endif    
        dimension aMark[m.dm_CountMarks]
        for m.j = 1 to m.dm_CountMarks step 1
            aMark[m.j]= oWordObj.ActiveDocument.Bookmarks(m.j).Name
        endfor
        
        
    *-- Substituting BookMarks
        local m.dm_MarkName    as String
        local m.dm_Expression  as String
        m.dm_MarkName    = ""
        m.dm_Expression  = ""
        
        for m.i = 1 to m.dm_CountMarks step 1
            
            *-- BookMark Name
                m.dm_MarkName = upper(alltrim(aMark[m.i]))
        
            *-- Building Expression
                m.dm_Expression = ""
                *wait window m.dm_MarkName
                do case

                   case m.dm_MarkName=="BK_DEL01" ;
                     or m.dm_MarkName=="BK_DEL02" ;
                     or m.dm_MarkName=="BK_DEL03" ;
                     or m.dm_MarkName=="BK_DEL04" ;
                     or m.dm_MarkName=="BK_DEL05" 
                        
                        if upper(alltrim(anag.sesso))=="M" then
                           m.dm_Expression = "del"
                        else
                           m.dm_Expression = "della"
                        endif   

                   case m.dm_MarkName=="BK_IL01" ;
                     or m.dm_MarkName=="BK_IL02" ;
                     or m.dm_MarkName=="BK_IL03" ;
                     or m.dm_MarkName=="BK_IL04" ;
                     or m.dm_MarkName=="BK_IL05" 
                        
                        if upper(alltrim(anag.sesso))=="M" then
                           m.dm_Expression = "il"
                        else
                           m.dm_Expression = "la"
                        endif   

                   case m.dm_MarkName=="BK_INV01" ;
                     or m.dm_MarkName=="BK_INV02" ;
                     or m.dm_MarkName=="BK_INV03" ;
                     or m.dm_MarkName=="BK_INV04" ;
                     or m.dm_MarkName=="BK_INV05" 
                        
                        if upper(alltrim(anag.sesso))=="M" then
                           m.dm_Expression = "invitandolo"
                        else
                           m.dm_Expression = "invitandola"
                        endif   

                
                   case m.dm_MarkName=="BK_MAT_POSTO_FUNZIONE01" ;
                     or m.dm_MarkName=="BK_MAT_POSTO_FUNZIONE02" ;
                     or m.dm_MarkName=="BK_MAT_POSTO_FUNZIONE03" ;
                     or m.dm_MarkName=="BK_MAT_POSTO_FUNZIONE04" ;
                     or m.dm_MarkName=="BK_MAT_POSTO_FUNZIONE05" 
                        m.dm_Expression = alltrim(m.pf_maturato)

                   case m.dm_MarkName=="BK_TIPO_LISTA01" ;
                     or m.dm_MarkName=="BK_TIPO_LISTA02" ;
                     or m.dm_MarkName=="BK_TIPO_LISTA03" ;
                     or m.dm_MarkName=="BK_TIPO_LISTA04" ;
                     or m.dm_MarkName=="BK_TIPO_LISTA05" 
                        m.dm_Expression = alltrim(epublist.pbls_tipo)
                
                   case m.dm_MarkName=="BK_DATA01" ;
                     or m.dm_MarkName=="BK_DATA02" ;
                     or m.dm_MarkName=="BK_DATA03" ;
                     or m.dm_MarkName=="BK_DATA04" ;
                     or m.dm_MarkName=="BK_DATA05" 
                        m.dm_Expression = dtoc(m.xiData)
                
                   case m.dm_MarkName=="BK_DIPENDENTE01" ;
                     or m.dm_MarkName=="BK_DIPENDENTE02" ;
                     or m.dm_MarkName=="BK_DIPENDENTE03" ;
                     or m.dm_MarkName=="BK_DIPENDENTE04" ;
                     or m.dm_MarkName=="BK_DIPENDENTE05" 
                        m.dm_Expression = alltrim(tdomanda.cognome)+" "+alltrim(tdomanda.nome)

                   case m.dm_MarkName=="BK_AREA01" ;
                     or m.dm_MarkName=="BK_AREA02" ;
                     or m.dm_MarkName=="BK_AREA03" ;
                     or m.dm_MarkName=="BK_AREA04" ;
                     or m.dm_MarkName=="BK_AREA05" 
                        m.dm_Expression = substr(alltrim(tdomanda.qualifica),1,1)


                   case m.dm_MarkName=="BK_ECONOMICA01" ;
                     or m.dm_MarkName=="BK_ECONOMICA02" ;
                     or m.dm_MarkName=="BK_ECONOMICA03" ;
                     or m.dm_MarkName=="BK_ECONOMICA04" ;
                     or m.dm_MarkName=="BK_ECONOMICA05" 
                        m.dm_Expression = alltrim(tdomanda.qualifica)

                   case m.dm_MarkName=="BK_RUOLIMAE01" ;
                     or m.dm_MarkName=="BK_RUOLIMAE02" ;
                     or m.dm_MarkName=="BK_RUOLIMAE03" ;
                     or m.dm_MarkName=="BK_RUOLIMAE04" ;
                     or m.dm_MarkName=="BK_RUOLIMAE05" 
                     
                        m.dm_Expression = dtoc(tdomanda.druolimae)

                   case m.dm_MarkName=="BK_POSTOFUNZIONE01" ;
                     or m.dm_MarkName=="BK_POSTOFUNZIONE02" ;
                     or m.dm_MarkName=="BK_POSTOFUNZIONE03" ;
                     or m.dm_MarkName=="BK_POSTOFUNZIONE04" ;
                     or m.dm_MarkName=="BK_POSTOFUNZIONE05" 
                        m.dm_Expression = alltrim(trlist.pfdesc)


                   case m.dm_MarkName=="BK_PF01" ;
                     or m.dm_MarkName=="BK_PF02" ;
                     or m.dm_MarkName=="BK_PF03" ;
                     or m.dm_MarkName=="BK_PF04" ;
                     or m.dm_MarkName=="BK_PF05" 
                        m.dm_Expression = alltrim(profilo.pfdesc)

                   case m.dm_MarkName=="BK_SEDE_DESTINAZIONE01" ;
                     or m.dm_MarkName=="BK_SEDE_DESTINAZIONE02" ;
                     or m.dm_MarkName=="BK_SEDE_DESTINAZIONE03" ;
                     or m.dm_MarkName=="BK_SEDE_DESTINAZIONE04" ;
                     or m.dm_MarkName=="BK_SEDE_DESTINAZIONE05" 
                        m.dm_Expression = alltrim(trlist.rango)+" "+alltrim(trlist.sede)
                       
                   case m.dm_MarkName=="BK_PM2001" ;
                     or m.dm_MarkName=="BK_PM2002" ;
                     or m.dm_MarkName=="BK_PM2003" ;
                     or m.dm_MarkName=="BK_PM2004" ;
                     or m.dm_MarkName=="BK_PM2005" 
                        if anag.p20 = 1 then
                           m.dm_Expression = "SUPERIORE"
                        else
                           m.dm_Expression = "INFERIORE"
                        endif   

                   case m.dm_MarkName=="BK_MM_NUMERO01" ;
                     or m.dm_MarkName=="BK_MM_NUMERO02" ;
                     or m.dm_MarkName=="BK_MM_NUMERO03" ;
                     or m.dm_MarkName=="BK_MM_NUMERO04" ;
                     or m.dm_MarkName=="BK_MM_NUMERO05" 
                        m.dm_Expression = alltrim(epublist.mm_numero)

                   case m.dm_MarkName=="BK_MM_DEL01" ;
                     or m.dm_MarkName=="BK_MM_DEL02" ;
                     or m.dm_MarkName=="BK_MM_DEL03" ;
                     or m.dm_MarkName=="BK_MM_DEL04" ;
                     or m.dm_MarkName=="BK_MM_DEL05" 
                        m.dm_Expression = dtoc(epublist.mm_del)
                        
                   case m.dm_MarkName=="BK_PROFILO_PROFESSIONALE01" ;
                     or m.dm_MarkName=="BK_PROFILO_PROFESSIONALE02" ;
                     or m.dm_MarkName=="BK_PROFILO_PROFESSIONALE03" ;
                     or m.dm_MarkName=="BK_PROFILO_PROFESSIONALE04" ;
                     or m.dm_MarkName=="BK_PROFILO_PROFESSIONALE05" 
                        m.dm_Expression = alltrim(tdomanda.ppdesc)

                   case m.dm_MarkName=="BK_UFFICIO01" ;
                     or m.dm_MarkName=="BK_UFFICIO02" ;
                     or m.dm_MarkName=="BK_UFFICIO03" ;
                     or m.dm_MarkName=="BK_UFFICIO04" ;
                     or m.dm_MarkName=="BK_UFFICIO05" 
                        
                        if upper(alltrim(tdomanda.em)) == "M" then
                           m.dm_Expression = "l'Amministrazione Centrale"
                        else
                           select esede
                           locate for esede.ntp_ide = tdomanda.ntp_rif
                           if found("esede") then
                              m.dm_Expression = alltrim(esede.rango)+" "+alltrim(esede.sede)
                           else
                              m.dm_Expression = "?"
                           endif
                        endif   
                        
                   case m.dm_MarkName=="BK_SEDE_ATTUALE01" ;
                     or m.dm_MarkName=="BK_SEDE_ATTUALE02" ;
                     or m.dm_MarkName=="BK_SEDE_ATTUALE03" ;
                     or m.dm_MarkName=="BK_SEDE_ATTUALE04" ;
                     or m.dm_MarkName=="BK_SEDE_ATTUALE05" 
                        
                        if upper(alltrim(tdomanda.em)) == "M" then
                           m.dm_Expression = alltrim(tdomanda.sedea_dsc)
                        else
                           select esede
                           locate for esede.ntp_ide = tdomanda.ntp_rif
                           if found("esede") then
                              m.dm_Expression = alltrim(esede.rango)+" "+alltrim(esede.sede)
                           else
                              m.dm_Expression = "?"
                           endif
                        endif   
                        
                endcase

                
            *-- Check Expression
                if len(alltrim(m.dm_Expression)) = 0 then
                   m.dm_Expression = " "
                endif
                
                
            *-- Insertion Into Unit Into Model
                oWordObj.WordBasic.ww7_EditGoto(m.dm_MarkName)
                oWordObj.WordBasic.insert(m.dm_Expression)
                
        endfor
    
        *-- Visibility
            oWordObj.Visible = .t.
            
        
        *-- Printing
            oWordObj.Documents.Save
            oWordObj.Documents.Close
            oWordObj.Quit
            oWordObj = NULL
            
                
        *--  ReSet Base Informativa
             if between(m.pp_epublist,1,reccount("epublist")) then
                select epublist
                go m.pp_epublist
             endif

             if between(m.pp_tdomanda,1,reccount("tdomanda")) then
                select tdomanda
                go m.pp_tdomanda
             endif

             if between(m.pp_trlist,1,reccount("trlist")) then
                select trlist
                go m.pp_trlist
             endif

             if between(m.pp_anag,1,reccount("anag")) then
                select anag
                go m.pp_anag
             endif
             
    
    



